//timer per eseguire azioni contemporanee
#include <arduino-timer.h>
auto timer = timer_create_default();
// definizione lettore MP3
#include <SoftwareSerial.h>

#define ARDUINO_RX 8  //should connect to TX of the Serial MP3 Player module
#define ARDUINO_TX 7  //connect to RX of the module

SoftwareSerial mySerial(ARDUINO_RX, ARDUINO_TX);

static int8_t Send_buf[8] = { 0 };  // Buffer for Send commands.  // BETTER LOCALLY
static uint8_t ansbuf[10] = { 0 };  // Buffer for the answers.    // BETTER LOCALLY

String mp3Answer;  // Answer from the MP3.

/************ Command byte **************************/
#define CMD_NEXT_SONG 0X01  // Play next song.
#define CMD_PREV_SONG 0X02  // Play previous song.
#define CMD_PLAY_W_INDEX 0X03
#define CMD_VOLUME_UP 0X04
#define CMD_VOLUME_DOWN 0X05
#define CMD_SET_VOLUME 0X06
#define CMD_SNG_CYCL_PLAY 0X08  // Single Cycle Play.
#define CMD_SEL_DEV 0X09
#define CMD_SLEEP_MODE 0X0A
#define CMD_WAKE_UP 0X0B
#define CMD_RESET 0X0C
#define CMD_PLAY 0X0D
#define CMD_PAUSE 0X0E
#define CMD_PLAY_FOLDER_FILE 0X0F
#define CMD_STOP_PLAY 0X16
#define CMD_FOLDER_CYCLE 0X17
#define CMD_SHUFFLE_PLAY 0x18   //
#define CMD_SET_SNGL_CYCL 0X19  // Set single cycle.
#define CMD_SET_DAC 0X1A
#define DAC_ON 0X00
#define DAC_OFF 0X01
#define CMD_PLAY_W_VOL 0X22
#define CMD_PLAYING_N 0x4C
#define CMD_QUERY_STATUS 0x42
#define CMD_QUERY_VOLUME 0x43
#define CMD_QUERY_FLDR_TRACKS 0x4e
#define CMD_QUERY_TOT_TRACKS 0x48
#define CMD_QUERY_FLDR_COUNT 0x4f

/************ Opitons **************************/
#define DEV_TF 0X02

// definizione sensore IR
//#include <IRremoteInt.h>
uint32_t Previous;
#include <IRremote.h>     // use the library
int receiver = 4;         // pin 4 of IR receiver to Arduino digital pin 4
IRrecv irrecv(receiver);  // create instance of 'irrecv'
decode_results results;

// remote code
#define button_1 0xFF22DD
#define button_2 0xFFC23D
#define button_3 0xFFE01F
#define button_4 0xFF906F
#define button_5 0xFF6897
#define button_6 0xFFB04F
#define button_7 0xFF30CF
#define button_8 0xFF7A85
#define btnTimer 0xFF629D
#define btnDwn 0xFF10EF
#define btnUp 0xFF5AA5
#define buttonON 0xFFA25D
#define buttonOFF 0xFFE21D

/*Definizione canali LED
10 anello esterno 0
9 anello 1
6 anello 2
5 anello interno 3
3 luce bianca 4
*/
const int channels = 5;
int pwmChannels[channels] = { 10, 9, 6, 5, 3 };

void setup() {


  Serial.begin(9600);  // for serial monitor output
    // set all PWM channels to outputs
  for (int index = 0; index < channels - 1; index++)
    pinMode(pwmChannels[index], OUTPUT);
  mySerial.begin(9600);              //Start our Serial coms for THE MP3
  delay(500);                        // wait for init
  sendCommand(CMD_SEL_DEV, DEV_TF);  // selezione sd card
  delay(500);
  sendCommand(CMD_SET_VOLUME, 0x1E);  // start with volume at maximum 30
  irrecv.enableIRIn();                // Start the receiver

  sendCommand(CMD_PLAY_W_INDEX, 4);  ////index 3
  delay(900);
  sendCommand(CMD_SNG_CYCL_PLAY, 2);
}

int maxBright = 32;  //luminosità di defalut
int speed = 15;      // velocità led default
bool count = false;

bool On_Light(void *argument /* optional argument given to in/at/every */) {

  for (int x = 0; x <= 255; x++) {
    // make brighter
    analogWrite(pwmChannels[4], x);
    // wait a short while
    delay(1);
  }

  return false;  // to repeat the action - false to stop
}

bool OFF_Light(void *argument /* optional argument given to in/at/every */) {


  // dim
  analogWrite(pwmChannels[4], 0);
  // wait a short while
  sendCommand(CMD_SNG_CYCL_PLAY, 2);
  speed = 25;
  return false;  // to repeat the action - false to stop
}

void loop() {
  timer.tick();

  if (irrecv.decode(&results))  // have we received an IR signal?
  {
    Serial.println(results.value, HEX);  // display it on serial monitor in hexadecimal

    if (results.value == 0xFFFFFFFF) {
      results.value = Previous;
    }
    switch (results.value) {
      case buttonON:
        // time travel
        Serial.println("button_ON Pressed");
        // play audio track 1
        break;

      case buttonOFF:
        Serial.println("button_OFF Pressed");
        // time travel
        speed = 5;
        sendCommand(CMD_PLAY_W_INDEX, 3);  //index 2
        analogWrite(pwmChannels[4], 255);
        //analogWrite(pwmChannels[4], 255);
        timer.in(3000, OFF_Light);

        break;

      case btnTimer:
        // time travel
        Serial.println("Timer Pressed");
        sendCommand(CMD_PLAY_W_INDEX, 7);  //index7
        if (count == true && speed < 35) {
          speed = speed + 10;
          Serial.println("diminuisci velocità");
          Serial.println(speed);
        } else count = false;
        if (count == false && speed > 5) {
          speed = speed - 10;
          Serial.println("aumenta velocità");
          Serial.println(speed);
        } else count = true;
        sendCommand(CMD_SNG_CYCL_PLAY, 2);
        break;

      case button_1:
        // time travel
        Serial.println("button_1 Pressed");
        // play audio track 1
        sendCommand(CMD_PLAY_W_INDEX, 2);  //index 1
        break;

      case button_2:
        // smooth chase
        // stop current audio and play audio track
        sendCommand(CMD_PLAY_W_INDEX, 3);  //index 2
        Serial.println("button_2 Pressed");
        break;

      case button_3:
        // thirty fps
        // stop current audio and play audio track
        sendCommand(CMD_PLAY_W_INDEX, 4);  //index 3
        Serial.println("button_3 Pressed");
        break;

      case button_4:
        // 24 fps
        Serial.println("button_4 Pressed");
        // stop current audio and play audio track
        sendCommand(CMD_PLAY_W_INDEX, 5);  //index 5
        break;

      case button_5:
        //24 fps simple
        // stop current audio and play audio track
        sendCommand(CMD_PLAY_W_INDEX, 6);
        Serial.println("button_5 Pressed");  //index 6
        break;

      case button_6:
        //Rad Chase
        sendCommand(CMD_PLAY_W_INDEX, 7);  //index7
        // stop current audio and play audio track
        Serial.println("button_6 Pressed");
        break;

      case button_7:
        //Rad Chase
        // stop current audio and play audio track
        sendCommand(CMD_PLAY_W_INDEX, 8);  //index7
        Serial.println("button_7 Pressed");
        break;

      case button_8:
        //Rainbow Chase
        // stop current audio and play audio track
        sendCommand(CMD_PLAY_W_INDEX, 11);  //index10
        Serial.println("button_8 Pressed");
        break;

        // button up pressed, decrease delay timers - go faster
      case btnUp:
        Serial.println("BtnUp pressed");
        if (maxBright <= 255) {  //aumenta luninosità
          maxBright = min(255, maxBright + 16);
          Serial.println(maxBright);
        }
        break;

        // button down pressed increase delays - go slower
      case btnDwn:
        if (maxBright > 20) {                   //diminuisci luminosità
          maxBright = max(16, maxBright - 16);  // set the LED on
          Serial.println(maxBright);
        }
        Serial.println("BtnDown pressed");
        break;
    }

    while (!irrecv.isIdle())
      ;               // if not idle, wait till complete
    irrecv.resume();  // next value
  }
  // cycle through each led "ring".
  for (int index = 0; index < channels - 1; index++) {
    // fade in, hold for a bit, then fade out...
    for (int x = 0; x <= speed; x++) {
      // make brighter
      analogWrite(pwmChannels[index], maxBright * ((float)x) / speed);
      // wait a short while
      delay(1);
    }

    // keep the LED max brightness for a bit
    delay(5);

    // fade out
    for (int x = speed; x >= 0; x--) {
      // dim
      analogWrite(pwmChannels[index], maxBright * ((float)x) / speed);
      // wait a short while
      delay(8);
    }
    // back to the top of loop for the next "ring"
  }

  // finished with all 5 "rings", back to the top of loop()!
}



/********************************************************************************/
/*Function: Send command to the MP3                                         */
/*Parameter:-int8_t command                                                     */
/*Parameter:-int16_ dat  parameter for the command                              */


void sendCommand(int8_t command, int16_t dat) {
  delay(20);
  Send_buf[0] = 0x7e;                //starting byte
  Send_buf[1] = 0xff;                //version
  Send_buf[2] = 0x06;                //the number of bytes of the command without starting byte and ending byte
  Send_buf[3] = command;             //
  Send_buf[4] = 0x00;                //0x00 = no feedback, 0x01 = feedback
  Send_buf[5] = (int8_t)(dat >> 8);  //datah
  Send_buf[6] = (int8_t)(dat);       //datal
  Send_buf[7] = 0xef;                //ending byte
  for (uint8_t i = 0; i < 8; i++)    //
  {
    mySerial.write(Send_buf[i]);     //send bit to serial mp3
    Serial.print(Send_buf[i], HEX);  //send bit to serial monitor in pc
  }
  Serial.println();
}